local WHP = {
	Event = {},
}
local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	--AS.data.meter_x = x - self.originalXDiff
	--AS.data.meter_y = y - self.originalYDiff
  end
end




function WHP.Event.LoadEnd(identifier)
	if identifier == "WhoHealsPVP" then	
		print("WhoHealsPVP loaded. /WHP")
	end
end


	
-- start frames
local main = UI.CreateContext("UI")

local activeHealers = {}
local pendingHeals = {}

    bar = UI.CreateFrame("Frame", "bar", main)
	bar.name1 = UI.CreateFrame("Text", "name", bar)
	bar.texture1 = UI.CreateFrame("Texture", "image", bar)
	
	bar.name2 = UI.CreateFrame("Text", "name2", bar)
	bar.texture2 = UI.CreateFrame("Texture", "image", bar)
	
	bar.name3 = UI.CreateFrame("Text", "name3", bar)
	bar.texture3 = UI.CreateFrame("Texture", "image", bar)
	
bar:ClearAll()

bar:SetWidth(75)
bar:SetHeight(25)

bar.name1:SetText("Name 1")
bar.name2:SetText("Name 2")
bar.name3:SetText("Name 3")
bar.texture1:SetTexture("WhoHealsPVP", "bar.PNG")
bar.texture2:SetTexture("WhoHealsPVP", "bar.PNG")
bar.texture3:SetTexture("WhoHealsPVP", "bar.PNG")

bar.texture1:SetWidth(250)
bar.texture1:SetHeight(80)

bar.texture2:SetWidth(250)
bar.texture2:SetHeight(80)
bar.texture3:SetWidth(250)
bar.texture3:SetHeight(80)




bar.name1:SetLayer(3)
bar.name1:SetFontSize(20)
bar.name1:SetFontColor(1,1,1,1)

bar.name2:SetLayer(3)
bar.name2:SetFontSize(20)
bar.name2:SetFontColor(1,1,1,1)

bar.name3:SetLayer(3)
bar.name3:SetFontSize(20)
bar.name3:SetFontColor(1,1,1,1)






bar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0,0)
bar.name1:SetPoint("CENTER",bar.texture1,"CENTER")
bar.name2:SetPoint("CENTER",bar.texture2,"CENTER")
bar.name3:SetPoint("CENTER",bar.texture3,"CENTER")
bar.texture1:SetPoint("CENTER",bar,"CENTER",0,75)
bar.texture2:SetPoint("CENTER",bar,"CENTER",0,150)
bar.texture3:SetPoint("CENTER",bar,"CENTER",0,225)


  bar:SetAlpha(1)
  bar:SetVisible(true)
  bar:SetBackgroundColor(0,0,0)
AddDragFrame(bar)
  

-------

	
   	function WHP.Event.Heal(info)
	if Inspect.Unit.Detail(info.caster) == nil then return end
	if info.heal and Inspect.Unit.Detail(info.caster).relation == "hostile" then
	 
	local data = {Inspect.Unit.Detail(info.caster).name, info.heal}
	table.insert(pendingHeals, data)
	end

	end

local lastCall = Inspect.Time.Real()
--local lastCall2 = lastCall
--local lastCall3 = lastCall




function fade()
local now = Inspect.Time.Real()
	if (now<lastCall+.3) then 
		return
	end
	
	local found = false
	
	if table.getn(pendingHeals) > 0 then
	local popper = table.remove(pendingHeals)
	
	for i,v in pairs(activeHealers) do
		if tostring(popper[1]) == tostring(v[1]) then
		v[2] = v[2] + popper[2]
		found = true
		end
		end
		
	if (table.getn(activeHealers)<1) or (found == false) then
	table.insert(activeHealers,popper)
	end	
	end



		

	
	--if (now>lastCall2+.5) then 

  
  
		
		
	
	
	if table.getn(activeHealers) >0 then 
	
	--[[
		local maxx =0
		for i,v in pairs(activeHealers) do
			if v[2]>maxx then
			maxx = v[2]
			end
			
			end
		--]]
		local decay = activeHealers[1][2] * .005 
		
		for i,v in pairs(activeHealers) do
		
			v[2] = math.floor(v[2] - decay)
		
		end
		
		--lastCall3 = now
	end
	
	
	table.sort(activeHealers, function(a,b) return a[2]>b[2] end)
 
  for i,v in pairs(activeHealers) do
	if v[2] <=0 then
	table.remove(activeHealers, i)
	end
	end
	
	if table.getn(activeHealers) >= 3 then
	bar.name1:SetText(activeHealers[1][1] .. " : " .. activeHealers[1][2])
	bar.name2:SetText(activeHealers[2][1] .. " : " .. activeHealers[2][2])
	bar.name3:SetText(activeHealers[3][1] .. " : " .. activeHealers[3][2])
	
	bar.name1:SetVisible(true)
	bar.name2:SetVisible(true)
	bar.name3:SetVisible(true)
	bar.texture1:SetVisible(true)
	bar.texture2:SetVisible(true)
	bar.texture3:SetVisible(true)
	
	
	
	elseif table.getn(activeHealers) == 2 then
	bar.name1:SetText(activeHealers[1][1] .. " : " .. activeHealers[1][2])
	bar.name2:SetText(activeHealers[2][1] .. " : " .. activeHealers[2][2])
	
	bar.name1:SetVisible(true)
	bar.name2:SetVisible(true)
	bar.name3:SetVisible(false)
	bar.texture1:SetVisible(true)
	bar.texture2:SetVisible(true)
	bar.texture3:SetVisible(false)
	
	elseif table.getn(activeHealers) == 1 then
	bar.name1:SetText(activeHealers[1][1] .. " : " .. activeHealers[1][2])
	
	bar.name1:SetVisible(true)
	bar.name2:SetVisible(false)
	bar.name3:SetVisible(false)
	bar.texture1:SetVisible(true)
	bar.texture2:SetVisible(false)
	bar.texture3:SetVisible(false)
	
	else
	bar.name1:SetVisible(false)
	bar.name2:SetVisible(false)
	bar.name3:SetVisible(false)
	bar.texture1:SetVisible(false)
	bar.texture2:SetVisible(false)
	bar.texture3:SetVisible(false)
	end

	
  
  --lastCall2 = now
--end
	
	

lastCall = now
end	
	
	function WHP.Event.SlashHandler(str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")

		if cmd == "move" then
		--bar:SetAlpha(not bar:GetAlpha())
		end
		
	end
	
	
table.insert(Event.Combat.Heal, {WHP.Event.Heal, "WhoHealsPVP", "Heals" })
table.insert(Event.System.Update.Begin, {fade, "WhoHealsPVP", "Fade"})
table.insert(Event.Addon.Load.End, 				{WHP.Event.LoadEnd, 			"WhoHealsPVP", "Init"})
table.insert(Command.Slash.Register("WHP"), 		{WHP.Event.SlashHandler, 	"WhoHealsPVP", "SlWHPh"})